package com.company.test.screen.testentity

import io.jmix.core.LoadContext
import io.jmix.ui.screen.*
import io.jmix.ui.screen.Target
import com.company.test.entity.TestEntity
import com.company.test.service.TestEntityService
import org.springframework.beans.factory.annotation.Autowired

@UiController("jt_TestEntity.browse")
@UiDescriptor("test-entity-browse.xml")
@LookupComponent("testEntitiesTable")
class TestEntityBrowse : StandardLookup<TestEntity>() {

    @Autowired
    private lateinit var testEntityService: TestEntityService

    @Install(to = "testEntitiesDl", target = Target.DATA_LOADER)
    private fun testEntitiesDlLoadDelegate(loadContext: LoadContext<TestEntity>?): MutableList<TestEntity> {
        val query = loadContext!!.query!!
        return testEntityService.loadEntities(query.firstResult, query.maxResults).toMutableList()
    }

    @Install(to = "pagination", subject = "totalCountDelegate")
    private fun paginationTotalCountDelegate(): Int {
        return testEntityService.totalCount()
    }


}