package com.company.test.service

import com.company.test.entity.TestEntity
import io.jmix.core.DataManager
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.stereotype.Component
import javax.annotation.PostConstruct

@Component
class TestEntityService {

    private lateinit var testEntities: List<TestEntity>

    @Autowired
    private lateinit var dataManager: DataManager

    fun loadEntities(firstRez: Int, maxRez: Int): List<TestEntity> {
        var to = firstRez + maxRez
        if (to > testEntities.size) to = testEntities.size

        return testEntities.subList(firstRez, to)
    }

    fun totalCount(): Int {
        return testEntities.size
    }

    @PostConstruct
    fun postConstr() {
        testEntities = (1..30).map {
            val testEntity = dataManager.create(TestEntity::class.java)
            testEntity.name = "test-$it"
            testEntity
        }
    }

}
